import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class GameBoard extends JPanel {
    // Funktionshilfen
    //int semesterCounter = 1; //TODO: ersetzen durch param von vorpanel

    // Grafiken
    ImageIcon backButtonIcon = new ImageIcon("graphics/backButton.png");
    ImageIcon gameBoardEmtpy = new ImageIcon("graphics/gameboardempty.png");
    ImageIcon gameBoardX = new ImageIcon("graphics/gameboardx.png");

    // Labels
    JLabel frameTitle = new JLabel("GameBoard");
    JLabel kontextText = new JLabel("Beispielhafter Kontext-Text");
    //kontextText.setFont(new Font("Roboto", Font.BOLD, 24)); //TODO setFont fixen

    JButton backButton = new JButton(backButtonIcon);
    // Eigene ModulButtons
    JButton leftPlayerModul1 = new JButton("Modul 1"); //TODO: Dynamische Namen durch abgleich mit Semester
    JButton leftPlayerModul2 = new JButton("Modul 2");
    JButton leftPlayerModul3 = new JButton("Modul 3");
    JButton leftPlayerModul4 = new JButton("Modul 4");
    JButton leftPlayerModul5 = new JButton("Modul 5");
    JButton leftPlayerModul6 = new JButton("Modul 6");
    JButton leftPlayerModul7 = new JButton("Reset");

    // Gegnerische ModulButtons
    JButton rightPlayerModul1 = new JButton("Modul 1");
    JButton rightPlayerModul2 = new JButton("Modul 2");
    JButton rightPlayerModul3 = new JButton("Modul 3");
    JButton rightPlayerModul4 = new JButton("Modul 4");
    JButton rightPlayerModul5 = new JButton("Modul 5");
    JButton rightPlayerModul6 = new JButton("Modul 6");
    JButton rightPlayerModul7 = new JButton("Bereit");

    public void buildPanel(MainFrame frame, int semesterCounter) {
        // Hauptlayout - BorderLayout für die Anordnung der Komponenten
        setLayout(new BorderLayout());

        // Panel für das Kontext-Text-Feld
        JPanel headerPanel = new JPanel();
        headerPanel.setLayout(new BorderLayout());
        headerPanel.add(kontextText, BorderLayout.WEST);
        headerPanel.add(backButton, BorderLayout.EAST);

        // Panel für die Buttons des linken Spielers (ganz links)
        JPanel leftButtonsPanel = new JPanel();
        leftButtonsPanel.setLayout(new GridLayout(7, 1)); // 6 Buttons untereinander
        leftButtonsPanel.add(leftPlayerModul1);
        leftButtonsPanel.add(leftPlayerModul2);
        leftButtonsPanel.add(leftPlayerModul3);
        leftButtonsPanel.add(leftPlayerModul4);
        leftButtonsPanel.add(leftPlayerModul5);
        leftButtonsPanel.add(leftPlayerModul6);
        leftButtonsPanel.add(leftPlayerModul7);

        // Panel für die Buttons des rechten Spielers (ganz rechts)
        JPanel rightButtonsPanel = new JPanel();
        rightButtonsPanel.setLayout(new GridLayout(7, 1)); // 6 Buttons untereinander
        rightButtonsPanel.add(rightPlayerModul1);
        rightButtonsPanel.add(rightPlayerModul2);
        rightButtonsPanel.add(rightPlayerModul3);
        rightButtonsPanel.add(rightPlayerModul4);
        rightButtonsPanel.add(rightPlayerModul5);
        rightButtonsPanel.add(rightPlayerModul6);
        rightButtonsPanel.add(rightPlayerModul7);

        // Spielfelder erstellen (eigenes und gegnerisches)
        int gridSize = GameController.semesterToBoardSize(semesterCounter); // Größe des Spielfelds
        // Spielfelder werden in BoardDisplay erstellt
        //JPanel ownBoardPanel = new JPanel(new GridLayout(gridSize, gridSize));
        //JPanel opponentBoardPanel = new JPanel(new GridLayout(gridSize, gridSize));
        JPanel ownBoardPanel = new BoardDisplay(gridSize, gameBoardEmtpy);
        JPanel opponentBoardPanel = new BoardDisplay(gridSize, gameBoardEmtpy);

        /* Alter code ohne BoardDisplay
        // Buttons für das eigene Spielfeld hinzufügen
        for (int i = 0; i < gridSize; i++) {
            for (int j = 0; j < gridSize; j++) {
                ownBoardPanel.add(new JButton(gameBoardEmtpy));
            }
        }

        // Buttons für das gegnerische Spielfeld hinzufügen
        for (int i = 0; i < gridSize; i++) {
            for (int j = 0; j < gridSize; j++) {
                opponentBoardPanel.add(new JButton(gameBoardEmtpy));
            }
        }
        */

        // Panel für beide Spielfelder (nebeneinander in der Mitte)
        JPanel centerPanel = new JPanel();
        centerPanel.setLayout(new GridLayout(1, 2, 20, 0)); // 2 Spielfelder nebeneinander, mit Abstand von 20 Pixeln
        centerPanel.add(ownBoardPanel);
        centerPanel.add(opponentBoardPanel);

        // Panels dem Hauptlayout hinzufügen
        add(leftButtonsPanel, BorderLayout.WEST);
        add(rightButtonsPanel, BorderLayout.EAST);
        add(headerPanel, BorderLayout.NORTH);
        add(centerPanel, BorderLayout.CENTER);
    }

    GameBoard(MainFrame frame, int semesterCounter,Player p1, Player p2) {
        buildPanel(frame, semesterCounter);
        /*
        rightPlayerRightButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                toggleRightPlayerIcon();
                updateTextFields();
            }
        }); */
        backButton.addActionListener(e -> frame.showPanel("MainMenu"));
    }
}
